angular.module('beamng.apps')
.directive('infoGenerator', ['$document', function ($document) {
  return {
  templateUrl: '/ui/modules/apps/infoGenerator/app.html',
  replace: true,
  link: function (element) {
	let All = [
	"ConfigurationNameInputInfoGen","DescriptionInputInfoGen","BodyStyleInputInfoGen","DrivetrainInputInfoGen","FuelTypeInputInfoGen","TransmissionInputInfoGen",
	"WeightInputInfoGen","ValueInputInfoGen","PowerInputInfoGen","WeightPowerInputInfoGen","PowerPeakRPMInputInfoGen","TorqueInputInfoGen",
	"PerfClassInputInfoGen","TorquePeakRPMInputInfoGen","BrakingGInputInfoGen","PopulationInputInfoGen","PropulsionInputInfoGen","YearsMaxInputInfoGen",
	"YearsMinInputInfoGen","zeroTo100kmhInputInfoGen","zeroTo60mphInputInfoGen","br100kmhTo0InputInfoGen","br60mphTo0InputInfoGen","OffRoadScoreInputInfoGen",
	"TopSpeedInputInfoGen"],
	AllInJson = [
	"  \\\"Configuration","  \\\"Description","  \\\"Body Style","  \\\"Drivetrain","  \\\"Fuel Type","  \\\"Transmission",
	"  \\\"Weight","  \\\"Value","  \\\"Power","  \\\"Weight/Power","  \\\"PowerPeakRPM","  \\\"Torque",
	"  \\\"Performance Class","  \\\"TorquePeakRPM","  \\\"Braking G","  \\\"Population","  \\\"Propulsion","  \\\"Years\\\":{\\\n    \\\"max",
	"    \\\"min","  },\\\n  \\\"0-100 km/h","  \\\"0-60 mph","  \\\"100-0 km/h","  \\\"60-0 mph","  \\\"Off-Road Score",
	"  \\\"Top Speed"];
	$document.on('keydown', function(e){
		if (e.keyCode == 13) {
			for (index in All) {
				if (e.target.id != "DescriptionInputInfoGen"){
					if (e.target.id == All[index]) e.preventDefault()
				}
			}
		};
		if (e.keyCode == 8 && e.target.nodeName == "TEXTAREA") {
			for (index in All) {
				if (e.target.id == All[index]) {
					document.getElementById([All[index]]).value = document.getElementById([All[index]]).value.slice(0, -1)
				}
			}
		}
	});
	function Reset() {
		for (index in All) {document.getElementById([All[index]]).value = ''};
		document.activeElement.blur()
	};
	Reset();
	bngApi.engineLua('scripts_infoGenerator_infoGenerator.StyleChangeChecking("Set")');
	let ConfigType = "Factory",
	InductionType = "NA";

	document.getElementById("GenerateInfoGen").addEventListener("click", function () {
		bngApi.engineLua('scripts_infoGenerator_infoGenerator.Generate()');
		if (document.getElementById("DescriptionInputInfoGen").value == '') document.getElementById("DescriptionInputInfoGen").value = 'Generated with "Info Generator"'
	});

	document.getElementById("CreateInfoGen").addEventListener("click", function () {
		if (document.getElementById("TopSpeedInputInfoGen").value.length < 1 || document.getElementById("OffRoadScoreInputInfoGen").value.length < 1 || document.getElementById("ConfigurationNameInputInfoGen").value.length < 1) {console.log("err")} else {
			let temp = '';
			temp += "{\\n";
			for (index in All) {
				let NumOrStr = '\\"',
				Comma = ',';
				if (All[index] != "PerfClassInputInfoGen" && (Number(document.getElementById(All[index]).value) || Number(document.getElementById(All[index]).value == 0))) NumOrStr = '';
				if (All[index] == "YearsMinInputInfoGen") Comma = '';
				temp += AllInJson[index] + '\\":' + NumOrStr + document.getElementById(All[index]).value.replace(/\\/g,'').replace(/"/g,'\\\\\\"').replace(/\n/g,'\\\\n') + NumOrStr + Comma + '\\n'
			};
			temp += "  \\\"Config Type\\\":" + '\\"' + ConfigType + '\\",\\n';
			temp += "  \\\"Induction Type\\\":" + '\\"' + InductionType + '\\"\\n';
			temp += "}";
			bngApi.engineLua('scripts_infoGenerator_infoGenerator.Create(\"' + temp + '\")')
		}
	});

	document.getElementById("ClearInfoGen").addEventListener("click", Reset);
	document.getElementById("AutoInfoGen").addEventListener("click", function () {
		bngApi.engineLua('scripts_infoGenerator_infoGenerator.AutoGenerationChecking()')
	});

	let pressButton = false,
	pressButton2 = false,
	pressButtonTimer,
	pressButtonTimer2,
	animationTimer;

	document.getElementById("mainInfoGen").addEventListener("mousedown", function(e) {
		if(e.button === 0) {
			if (e.target.textContent == 'Clear') {
				pressButton = true;
				let scale = 0;
				animationTimer = setInterval( ()=> {
					scale += 0.32;
					if (scale > 30) {document.getElementById("ClearInfoGen").style.transform = 'scale(' + (scale - 29) + ')'}
				},10);
				pressButtonTimer = setTimeout( () => {
					bngApi.engineLua('scripts_infoGenerator_infoGenerator.StyleChangeChecking("Remove")');
					bngApi.engineLua('reloadUI()')
				}, 2500)
			};
			if (e.target.textContent == 'Auto Create' || e.target.textContent == '5.00$') {
				pressButton = true
				pressButtonTimer = setTimeout( () => {
					bngApi.engineLua('scripts_infoGenerator_infoGenerator.StyleChangeChecking("Change", "#CC0", "#330")')
				}, 1000)
			};
			if (e.target.textContent == 'Create') {
				pressButton = true
				pressButtonTimer = setTimeout( () => {
					bngApi.engineLua('scripts_infoGenerator_infoGenerator.StyleChangeChecking("Change", "#C60", "#420")')
				}, 1000)
			};
			if (e.target.textContent == 'Generate') {
				pressButton = true
				pressButtonTimer = setTimeout( () => {
					bngApi.engineLua('scripts_infoGenerator_infoGenerator.StyleChangeChecking("Change", "#0C0", "#030")')
				}, 1000)
			};
			if (e.target.textContent == 'Clear') {
				pressButton2 = true
				pressButtonTimer2 = setTimeout( () => {
					bngApi.engineLua('scripts_infoGenerator_infoGenerator.StyleChangeChecking("Change", "#C00", "#400")')
				}, 1000)
			}
		}
	});

	document.addEventListener('mouseup', function(e) {
		if (pressButton) {
			pressButton = false;
			clearTimeout(pressButtonTimer);
			clearInterval(animationTimer);
			document.getElementById("ClearInfoGen").style.transform = 'scale(' + 1 + ')'
		};
		if (pressButton2) {
			pressButton2 = false;
			clearTimeout(pressButtonTimer2)
		}
	});

	setTimeout( () => {if (vueI18n.global.locale == 'ru_RU') document.getElementById("AutorInfoGen").textContent = "Ns Pro"},1000)
  }}}]);